#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf libxml2-2.8.0.tar.gz
    cd libxml2-2.8.0
    ./configure --prefix=/usr --disable-silent-rules --disable-static \
	--with-pic --without-debug --without-ftp --without-http \
	--without-iconv --without-modules
    make
    strip -R .note -R .comment .libs/libxml2.so.2
    mkdir -p ../libxml2/lib
    cp .libs/libxml2.so.2 ../libxml2/lib/
    cd ..
    rm -rf libxml2-2.8.0
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
